# tasks.py
#from celery import shared_task
#from background_task import background
from django.db import transaction
from .models import Campaign
import requests
import time
from clmainApp.whatsapp_templates import send_voucher_notification
from django.utils import timezone
import random
random_interval_min = 30
random_interval_max = 120
#@shared_task(bind=True) #for celery 
#@background(schedule=0)  # Run in 10 seconds
def send_campaign_messages_async(campaign_id):
    print(f" ******* send_campaign_messages Started")
    # import pdb
    # pdb.set_trace()
    print(" ******* campaign_id",campaign_id)
    campaign = Campaign.objects.get(pk=campaign_id)
    pending_messages = campaign.messages.filter(msg_status__in=['pending','failed'])
    campaign.status = 'running'
    campaign.save()
    campaign_msg_prefix = campaign.msg_prefix
    #import pdb
    #pdb.set_trace()
    #if pending_messages.count() > 2 :pdb.set_trace()
    counter = 0
    # success_count = campaign.success_count
    # failed_count = campaign.failed_count
    print(" ******* Messages To sent : ",pending_messages.count())
    for message in pending_messages:
        print(f" ******* sending Message NO {counter} after 10 seconds ")
        #time.sleep(10)
        counter = counter + 1 
        #print(f"sending Message NO {counter}")
        try:
            ptv = message
            pt_obj = message.patient
            pt_number_1 = pt_obj.number_1
            pt_fullname = pt_obj.fullname
            is_msg_sent = send_voucher_notification(campaign_msg_prefix,pt_number_1,True,pt_fullname,ptv.voucher_code_assigned,ptv.expires_at,
                ptv.discount_amount_sessions_assigned,ptv.max_sessions,ptv.discount_amount_visits_assigned,ptv.max_visits)
            # import pdb
            # pdb.set_trace()
            #with transaction.atomic():
            # Update message
            message.attempts += 1
            message.try_send_at = timezone.now()
            
            if is_msg_sent:
                message.is_wa_sent = True
                message.msg_status = 'sent'
                print(f" ******* sending Message NO {counter} sent ")
                #success_count += 1
            else:
                message.is_wa_sent = False
                message.msg_status = 'failed'
                print(f" ******* sending Message NO {counter} failed ")
                #failed_count += 1
            
            # Save message immediately
            message.save(update_fields=[
                'attempts', 
                'is_wa_sent', 
                'msg_status', 
                'try_send_at'
            ])
            # message.attempts += 1
            # #message.response = response.json()
            # if is_msg_sent:
            #     message.is_wa_sent = True
            #     message.msg_status = 'sent'
            #     success_count = success_count + 1
            #     campaign.success_count = success_count
            #     #campaign.success_count += 1
            # else:
            #     message.msg_status = 'failed'
            #     #campaign.failed_count += 1
            #     failed_count = failed_count + 1
            #     campaign.failed_count = failed_count
            
            # message.try_send_at = timezone.now()
            # message.save()
            #campaign.save()
            #print(campaign.success_count)
                
            # Throttle requests if needed
            time.sleep(random.randint(random_interval_min,random_interval_max))
            
        except Exception as e:
            message.msg_status = 'failed'
            message.is_wa_sent = False
            message.save(update_fields=[
                'attempts', 
                'is_wa_sent', 
                'msg_status', 
                'try_send_at'
            ])
            #failed_count += 1
            #message.msg_status = 'failed'
            #message.response = {'error': str(e)}
            #message.save()
            continue
    
    campaign.status = 'completed'
    campaign.save()
'''
pip install django-background-tasks  # Note the 's' at the end
INSTALLED_APPS = [
    ...
    'background_task',
    ...
]
python manage.py migrate

pip install celery redis  # Redis as message broker
your_project/
├── your_project/
│   ├── __init__.py
│   ├── celery.py   # NEW - Celery app config
│   ├── settings.py
│   └── urls.py
└── manage.py

'''